// WakKhenakEA1b
// 18-JAN-2009
// by jingodelcuyo
#property copyright "free"
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>
double OrderTimeOut=60.0;
double MyMaxLots=10.0;
int FridayCloseHour=22;
double Percent=10.0;
int StopLoss=300;
int TakeProfit=300;
datetime InitTime;
double old[31][9];
double new[31][9];
double SpreadNew;
double SpreadOld;
double StopLevelNew;
double StopLevelOld;
double Lots_New;
int otc[6];
int fh=0;
double lastOpen=0;
int bars=0;
int c[10], d[2];
double HA[8];

int init() {
   StopLevelOld=MarketInfo(Symbol(),MODE_STOPLEVEL);
   SpreadOld=MarketInfo(Symbol(),MODE_SPREAD);
   lot();
   return(0);
}

int deinit() {
   return(0);
}

int start() {
   int i, j;
   bool rev=true;
   orderTracking();
   events(0);
   if (Open[0]!=lastOpen) {
      lastOpen=Open[0];
      d[1]=d[0];
   }
   
   // The original request was:
   // "open buy when blue colour and close positon when red colour n automatic open sell when red colour"
   // using the custom indicator Heiken_Ashi+Smoothed Alert_2__1
   // The next 4 lines perform this function by reading buffers from the indicator and identifying a cross/reverse
   // according to the intent of the indicator
   int buffers=2;
   for (i=0; i<=buffers; i++) HA[i]=iCustom(Symbol(),0,"Heiken_Ashi_Smoothed_Alert_2__1",i,0);
   if (HA[0]<=HA[1]) d[0]=0; else d[0]=1;
   if (d[0]==d[1]) rev=false; // If no reversal is detected, rev=false
   
   // It turns out that the indicator detects too many reversals, escpecially during consolidations.
   // It also does not consistently find reversals that represent profitable trades (i.e. a buy signal can come at a
   // price that is higher than the last sell signal).
   // Therefore, some other indicator should be used to filter out as many unwanted reversing signals as possible.
   // Just as an example, I am using iMACD to remove reversing signals when the main line is close to zero.
   // This attempts to limit signals to higher highs and lower lows, but it doesn't always give profitable results.
   // I HAVE USED THIS FOR ILLUSTRATING THE EXAMPLE ONLY -- OTHER FILTERING STRATEGIES SHOULD BE TESTED
   double Q=MathAbs(NormalizeDouble((iMACD(Symbol(),0,6,30,6,5,0,0))/Point,2));
   if (Q<5.0) rev=false;
   
   // If rev=true, then execute the trade according to the HA signal.
   if (rev) int tkt=trade(d[0]);
   
   return(0);
}

// The rest of the EA is just code snippets, and has not necessarily been customized to this specific task.
int trade(int d) {
   int t=0;
   if (OrderSelect(0,SELECT_BY_POS)) if (OrderType()!=d) closeOrder(OrderTicket());
   if (DayOfWeek()==0) return(0);
   if ((DayOfWeek()==5 && Hour()>=FridayCloseHour) || DayOfWeek()>=6) return;
   if (lot()==false) return;
   t=openOrder(d);
   if (t>0) {
      orderTracking();
      events(0);
   }
   return(t);
}

int openOrder(int type) {
   string Sym=Symbol();
   int ticket=0, MN=0;
   double SL, TP, OP;
   datetime TL;
   if (type==0 && otc[0]==0 && otc[1]==0) {
      OP=Ask;
      TP=OP+TakeProfit*Point;
      SL=OP-StopLoss*Point;
      ticket=OrderSend(Symbol(),0,Lots_New,OP,2,SL,TP,"",MN);
   }
   if (type==1 && otc[1]==0 && otc[0]==0) {
      OP=Bid;
      TP=OP-TakeProfit*Point;
      SL=OP+StopLoss*Point;
      ticket=OrderSend(Symbol(),1,Lots_New,OP,2,SL,TP,"",MN);
   }
   if (ticket<0) if(errors(GetLastError())==false) return(-1);
   if (ticket>0) return(ticket); else return(0);
}

int closeOrder(int ticket) {
   double Price_Cls;
   if (OrderSelect(ticket,SELECT_BY_TICKET)) {
      switch (OrderType()) {
         case 0: Price_Cls=Bid; break;
         case 1: Price_Cls=Ask; break;
      }
      bool Ans=OrderClose(ticket,OrderLots(),Price_Cls,2);
      if (Ans==false) {
         if(errors(GetLastError())==false) return;
      }
   }
   orderTracking();
   events(0);
   return;
}

bool lot() {
   string Sym=Symbol();              
   double One_Lot=MarketInfo(Sym,MODE_MARGINREQUIRED);
   double Min_Lot=MarketInfo(Sym,MODE_MINLOT);
   double Step=MarketInfo(Sym,MODE_LOTSTEP);
   double Max_Lot=MarketInfo(Sym,MODE_MAXLOT);
   double Free=AccountFreeMargin();
   if (Max_Lot>MyMaxLots) Max_Lot=MyMaxLots;
   Lots_New=MathFloor(Free*Percent/100/One_Lot/Step)*Step;
   if (Lots_New*One_Lot>AccountFreeMargin()) {
      Alert ("********** AccountFreeMargin error in Lot calculation **********");
      return(false);
   }
   if (Lots_New<Min_Lot) Lots_New=Min_Lot;
   if (Lots_New>Max_Lot) Lots_New=Max_Lot;
   return(true);
}

int events(int rev) {
   bool s;
   for(int i=1;i<=old[0][0];i++) {
      s=false;
      for(int j=1;j<=new[0][0];j++) {
         if (old[i][1]==new[j][1]) {
            s=true;
            break;
         }
      }
      if (s==false) { // an order has closed 
      }
   }
   return;
}

int orderTracking() { // update order tracking
   int i=0;
   ArrayCopy(old, new);
   ArrayInitialize(new, 0);
   ArrayInitialize(otc, 0);
   for (int j=0; j<OrdersTotal(); j++) {
      if ((OrderSelect(j, SELECT_BY_POS)==true) && (OrderSymbol()==Symbol())) {
         i++;
         new[i][1]=OrderTicket();
         otc[OrderType()]++;
      }
   }
   new[0][0]=i;
}

bool errors(int error) { 
   if(error==0) return(false);
   switch(error) {
      case 129:
      case 135:
         RefreshRates();
         return(true);
      case 136:
         while(RefreshRates()==false) Sleep(1);
         return(true);
      case 146:
         Sleep(500);
         RefreshRates();
         return(true);
      case 2 :
      case 5 :
      case 64:
      case 133:
      default:
         return(false);
   }
}